#include <stdio.h>
#include <fcntl.h>

#include "db.h"


extern datum	firstkey();
extern datum	nextkey();


static DBM	*db = NULL;
static datum	key;


int
open_db ( file, is_dbm )
char	*file;
int	is_dbm;
{
	if (is_dbm) {
		if (dbminit(file) < 0)
			return (0);
	}
	else {
		if ((db = dbm_open(file, O_RDONLY, 0600)) == NULL)
			return (0);
	}

	return (1);
}

datum
first_key ()
{
	if (db == NULL) {
		key = firstkey();
		return (key);
	}
	else
		return (dbm_firstkey(db));
}

datum
next_key ()
{
	if (db == NULL) {
		key = nextkey(key);
		return (key);
	}
	else {
		return (dbm_nextkey(db));
	}
}

void
close_db()
{
	if (db == NULL)
		dbmclose();
	else
		dbm_close(db);
}
